#COMPILE EXE                                                                                                  
#INCLUDE "WIN32API.INC"                                                                        
#INCLUDE "appGenHelp.inc"                            
#include ".\appHelp.inc"                              
'#include "c:\pbwin10\appHelp\appHelp.inc"                                                                   
'#INCLUDE "debug.inc"                                                               
#RESOURCE pbr "appGenHelp.pbr"                                             
                                                      
'embedded resource data                                                               
'#RESOURCE ICON, GenHelp, "GenHelp.ico"                                   
'#RESOURCE MANIFEST, 1, "Manifest.XML"                    
'#RESOURCE VERSIONINFO                                      
'#RESOURCE FILEVERSION 4, 0, 1, 0
'#RESOURCE PRODUCTVERSION 4, 0, 1, 0
'#RESOURCE STRINGINFO "0409", "04B0"
'#RESOURCE VERSION$ "Comments",         "Generate help for applications"
'#RESOURCE VERSION$ "CompanyName",      "CGD Software"
'#RESOURCE VERSION$ "FileDescription",  "Application"
'#RESOURCE VERSION$ "FileVersion",      "Version 1.02 (04-20-2017)"
'#RESOURCE VERSION$ "InternalName",     "appHelp"                        
'#RESOURCE VERSION$ "LegalCopyright",   "No Copyright 2016"
'#RESOURCE VERSION$ "LegalTrademarks",  "None"                                                           
'#RESOURCE VERSION$ "OriginalFilename", "appHelp"
'#RESOURCE VERSION$ "ProductName",      "App Help Generator"
'#RESOURCE VERSION$ "ProductVersion",   "Version 1.0.0"              

$Ver = "1.09"                                        
                                                                            
FUNCTION PBMAIN                                                  
   LOCAL nStyle, hGraph AS long                                                                           
   DIALOG default FONT "arial", 10
   nStyle = %WS_THICKFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW PIXELS, 0, "Application to Create a Help File", , , 640, 400, nStyle TO hDlg
   nStyle = %TVS_EDITLABELS 'OR %WS_TABSTOP 'or %TVS_SHOWSELALWAYS       
   CONTROL ADD TREEVIEW, hDlg, %IDC_AppHelp_Treeview, "", 10, 5, 235, 330, nStyle
   control add label, hDlg, %IDC_Title, "", 250, 5, 370, 23
   control set color hDlg, %IDC_Title, %RGB_BLACK, %RGB_LIGHTGRAY
   control add label, hDlg, %IDC_Gap, "", 250, 28, 370, 12      
   control set color hDlg, %IDC_Gap, %RGB_white, %RGB_white
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN _
            OR %ES_NOHIDESEL 'or %WS_TABSTOP                                            
   CONTROL ADD TEXTBOX, hDlg, %IDC_Textbox, "", 250, 40, 370, 290, nStyle
   control set color hDlg, %IDC_Textbox, %RGB_BLACK, %RGB_white
   CONTROL ADD LINE, hDlg, %IDC_SplitBar, "", 246, 5, 3, 325, %SS_NOTIFY
   CONTROL ADD STATUSBAR, hDlg, %IDC_StatusBar, "", 0, 360, 700, 5                      
   DIALOG SHOW MODAL hDlg, CALL dlgProc
eND FUNCTION                                              
                                         
CALLBACK FUNCTION dlgProc()           
   LOCAL iRet, hAccel, hFont1, w, v, dx, flags, hIni, i, n, m, k, nStyle, tabUnits, fileNo AS LONG
   LOCAL hInst, hIcon, hParent, hChild, hRoot, hNext, hPrev, hSel, topic, hAfter, hMoveTo AS LONG
   local found, hBeginFind, notWholeWord, c1, c2 as long                               
   LOCAL ti, folder, progFolder, filter, f, s, ss, sItem, sParent AS STRING 
   LOCAL psz AS WSTRINGZ PTR, pNMHDR AS NMHDR PTR
   LOCAL pt AS POINTAPI, tvHitInfo AS TV_HITTESTINFO, p_tvdi AS TV_DISPINFO PTR, r AS RECT      
   STATIC wi, ht, x, y, yy, x1, x2, w1, w2, u, h, hh, wp, wu, hu, moving, hMove, splitting AS LONG
   STATIC hTreeview, hItem, hSavItem, savIndex, tabSpace, nPos, done, lastFound, hSelected AS LONG     
   static nFound, hLastFound, lastIndex, index, beginFind, insideTextbox as long
   STATIC sMove, sText, sFind, helpFile AS STRING                        
   STATIC numChildren, hchildren() AS LONG                        
   SELECT CASE CB.MSG                                                      
      CASE %WM_INITDIALOG                                                                          
         CONTROL HANDLE CB.HNDL, %IDC_Treeview TO hTreeview
         CONTROL HANDLE CB.HNDL, %IDC_Textbox TO hTextbox
         control handle cb.hndl, %IDC_Title to hTitle          
                                                                                                     
         'put GenHelp icon in explorer
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "appGenHelp", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND cb.hndl, %WM_SETICON, 0, hIcon                                   

         'define Windows data folder
         progFolder = specialFolder(%CSIDL_PROGRAM_FILES) + "\cgdSoftware\appGenHelp\"
         if exe.path$ = progFolder then 'program & data in Windows folders                                  
            dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
            dataFolder = dataFolder + "\cgdSoftware\appGenHelp\"
         else 'data in path of running program
            dataFolder = exe.path$ 
         end if
         
         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder                                         
         helpFile = dataFolder + "appGenHelp.ahp" 
         iniFile = dataFolder + "appGenHelp.ini"
         DIM dataFiles(1 TO 4) AS STRING
         s = COMMAND$(1)
         IF LEN(s) THEN                                                     
            thisFile = s                                                  
         ELSEIF ISFILE(iniFile) THEN                                               
            'DIM dataFiles(1 TO 4) AS STRING
            fileNo = FREEFILE: m = 0
            OPEN iniFile FOR INPUT AS fileNo                             
            FOR i = 1 TO 4                                                   
               LINE INPUT #fileNo, s
               IF LEN(s) THEN
                  INCR m: dataFiles(m) = s                  
               END IF
            NEXT i                                             
            CLOSE fileNo
            thisFile = dataFiles(1)
         END IF
         AttachMenu()
         IF isfile(thisFile) THEN  
            openTheFile
         end if
                                                       
         'set styles and fonts                                      
         FONT NEW "MS Sans Serif", 10 TO hFont                                    
         CONTROL SET FONT cb.hndl, %IDC_Textbox, hFont          
         CONTROL SET FONT cb.hndl, %IDC_Treeview, hFont
         FONT NEW "MS Sans Serif", 12 TO hFont1
         CONTROL SET FONT cb.hndl, %IDC_Title, hFont1
         nStyle = %EC_LEFTMARGIN or %EC_RIGHTMARGIN
         CONTROL SEND cb.hndl, %IDC_Textbox, %EM_SETMARGINS, nStyle, MAK(DWORD, 12, 12)
         
         'define accelerator keys                 
         REDIM ac(1 TO 9) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY
         ac(1).key   = %VK_F1                                 
         ac(1).cmd   = %IDM_ProgHelp
         
         ac(2).fvirt = %FVIRTKEY
         ac(2).key   = %VK_F2                               
         ac(2).cmd   = %IDM_OtherPane                                                               
         
         ac(3).fvirt = %FVIRTKEY
         ac(3).key   = %VK_F3
         ac(3).cmd   = %IDM_Next
         
         ac(4).fvirt = %FVIRTKEY OR %FShift
         ac(4).key   = %VK_F3                                                           
         ac(4).cmd   = %IDM_Prev
         
         ac(5).fvirt = %FVIRTKEY OR %FCONTROL
         ac(5).key   = %VK_F
         ac(5).cmd   = %IDM_Find
                                         
         ac(6).fVirt = %FVIRTKEY
         ac(6).key   = %VK_TAB
         ac(6).cmd   = %IDM_TAB
         
         ac(7).fvirt = %FVIRTKEY OR %FCONTROL                               
         ac(7).key   = %VK_A
         ac(7).cmd   = %IDM_SelAll
         
         ac(8).fvirt = %FVIRTKEY                               
         ac(8).key   = %VK_F5
         ac(8).cmd   = %IDM_RunHelp 

         ac(9).fvirt = %FVIRTKEY                               
         ac(9).key   = %VK_Escape
         ac(9).cmd   = %IDM_ESC 

         ACCEL ATTACH CBHNDL, ac() TO hAccel
         
         STATUSBAR SET PARTS CB.HNDL, %IDC_StatusBar, .56*wi, .32*wi, 9999
         statusbar set text CB.HNDL, %IDC_StatusBar, 1, 0, thisFile 
         
         'need to subclass textbox for right click menu
         origTextboxProc = SetWindowLong(hTextbox, %GWL_WNDPROC, CodePtr(subClassTextbox))
         
         DIALOG POST CB.HNDL,%WM_USER+500, 0, 0
      CASE %WM_USER+500 'show dialog for first time 
         'can show dialog here if needed
         showTreeview()
      CASE %WM_SIZE
         'resize controls
         wp = wi - x - 20                                                                               
         DIALOG GET CLIENT CB.HNDL TO wi, ht                                    
         control get client CB.HNDL, %IDC_Textbox to wp, h
         CONTROL GET SIZE CB.HNDL, %IDC_Treeview TO w, h                         
         CONTROL GET LOC CB.HNDL, %IDC_SplitBar TO x, y                 
         CONTROL SET SIZE CB.HNDL, %IDC_Title, wi - x - 36, y + 18              
         CONTROL SET SIZE CB.HNDL, %IDC_Gap, wi - x - 36, y + 12                         
         CONTROL SET SIZE CB.HNDL, %IDC_Textbox, wi - x - 20, ht - 65         
         CONTROL SET SIZE CB.HNDL, %IDC_Treeview, w, ht - 40
         CONTROL SET SIZE CB.HNDL, %IDC_SplitBar, 5, ht - 40                      
         STATUSBAR SET PARTS CB.HNDL, %IDC_StatusBar, .56*wi, .32*wi, 9999
      CASE %WM_SetCursor
         'show horizontal arrows if cursor is over splitter control
         iRet = GetDlgCtrlID (CB.WPARAM)
         IF iRet = %IDC_SplitBar THEN MOUSEPTR 9: FUNCTION = 1
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemove, lbuttonup
         SELECT CASE HI(WORD, CB.LPARAM)
            CASE %WM_LBUTTONDOWN
               if iRet = %IDC_Textbox then 'quit find
                  SendMessage hTextbox, %EM_SetReadOnly, 0, 0
                  sFind = "": lastFound = 0 
               end if                                                              
               'sets flag to indicate splitter action has started (no actual movement yet)
               IF iRet = %IDC_SplitBar THEN
                  Splitting = 1
                  CONTROL GET LOC  CB.HNDL, %IDC_Treeview  TO x1, y
                  CONTROL GET SIZE CB.HNDL, %IDC_Treeview  TO w1, h
                  CONTROL GET LOC  CB.HNDL, %IDC_Textbox  TO x2, yy
                  CONTROL GET SIZE CB.HNDL, %IDC_Textbox  TO w2, hh
                  CONTROL GET LOC  CB.HNDL, %IDC_SplitBar  TO u, v: x = u
               END IF
            CASE %WM_MOUSEMOVE
               'resizes windows and moves splitter bar to match mouse position (if position has changed)
               IF splitting THEN
                  GetCursorPos pt               'pt has xy screen coordinates in pixels
                  ScreenToClient CB.HNDL, pt    'pt now has client coordinates in pixels
                  IF pt.x <> x THEN             'mouse position has changed... resize
                     dx = pt.x - x
                     CONTROL SET LOC  CB.HNDL, %IDC_Treeview, x1, y
                     CONTROL SET SIZE CB.HNDL, %IDC_Treeview, w1 + dx, h                  

                     CONTROL SET LOC  CB.HNDL, %IDC_Title, x2 + dx, y
                     CONTROL SET SIZE CB.HNDL, %IDC_Title, w2 - dx - 16, 23
                     CONTROL SET LOC  CB.HNDL, %IDC_Gap, x2 + dx, y + 23
                     CONTROL SET SIZE CB.HNDL, %IDC_Gap, w2 - dx - 16, 12
                     
                     CONTROL SET LOC  CB.HNDL, %IDC_Textbox, x2 + dx, y + 35
                     CONTROL SET SIZE CB.HNDL, %IDC_Textbox, w2 - dx, h - 35
                     CONTROL SET LOC  CB.HNDL, %IDC_SplitBar, u + dx, y                        
                  END IF  
               END IF
            CASE %WM_LBUTTONUP
               'sets flag to say splitter action has ended
               Splitting = 0
         END SELECT     
      CASE %WM_NOTIFY
         IF CB.NMID = %IDC_Treeview THEN
            if CB.NMCODE = %NM_SETFOCUS then                         
               MENU SET STATE hMenu, 2, %MF_ENABLED
               MENU SET STATE hMenu, 3, %MF_disABLED
            END IF                                                      
            pNMHDR = CB.NMHDR                                         
            IF @pNMHDR.code = %TVN_SELCHANGEDW THEN                                       
               'directed here when treeview selection changes
               IF doNotNotify THEN EXIT FUNCTION
               treeview set bold CB.HNDL, %IDC_Treeview, hSelected, 0
               TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hItem                                   
               hSelected = hItem
               if hItem = 0 then exit function '... in process of exiting program                      
               treeview set bold CB.HNDL, %IDC_Treeview, hItem, 0
               lastIndex = index
               if fileChanged < 0 and lastIndex then 'textbox changed
                  fileChanged = 1: CONTROL GET TEXT CB.HNDL, %IDC_Textbox TO texts(lastIndex)
               end if
               TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hItem TO index 
               CONTROL SET TEXT CB.HNDL, %IDC_Textbox, texts(index)                                     
               TREEVIEW GET text CB.HNDL, %IDC_Treeview, hItem TO s                       
               control set text cb.hndl, %IDC_Title, space$(5) + s
               nWordWrap = editOpt(index).nWordWrap 
               tabSpaces = editOpt(index).TabSpaces
               if nWordwrap <> lastWordwrap then 
                  nWordwrap = lastWordwrap: wordwrapToggle()                        
               end if                                                  
               lastWordwrap = nWordwrap 
               tabUnits = 4 * tabSpaces                                      
               SendMessage hTextbox, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)
               'update last two panels of the staturbar                                 
               TREEVIEW GET PARENT hDlg, %IDC_Treeview, hItem TO hParent
               IF hParent THEN
                  TREEVIEW GET TEXT hDlg, %IDC_Treeview, hParent TO sParent
                  s = sParent + " : " + s
               END IF
               STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, s
               s = "Size: " + STR$(LEN(texts(index)))                        
               STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 3, 0, s
            ELSEIF CB.NMCODE = %TVN_BEGINLABELEDITW THEN
               'directed here when label editing begins
               TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hItem
               IF editLabel = 0 THEN FUNCTION = 1: EXIT FUNCTION              
            ELSEIF CB.NMCODE = %TVN_ENDLABELEDITW THEN
               'directed here when label editing ends
               SetFocus hTreeview 'keep focus on treeview                             
               p_tvdi = CB.LPARAM: ss = titles(index)
               psz = @p_tvdi.ITEM.pszText: IF psz THEN s = @psz
               if len(s) = 0 then s = ss
               'if len(s) = 0 then exit function
               treeview set text CB.HNDL, %IDC_Treeview, hItem, s
               TREEVIEW SELECT CB.HNDL, %IDC_Treeview, hItem
               control set text cb.hndl, %IDC_Title, space$(5) + s 
               titles(index) = s
               MENU SET STATE hMenu, 2, %MF_ENABLED
               MENU DRAW BAR CB.HNDL
               STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 2, 0, s 
               editLabel = 0: fileChanged = 1
            END IF                                                      
         END IF
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            case %IDC_Title
               IF CB.CTLMSG = %EN_SETFOCUS THEn
                  exit function
               end if                                                                                            
            CASE %IDC_Textbox
               IF CB.CTLMSG = %EN_SETFOCUS THEN 'entering textbox                      
                  insideTextbox = 1
                  if numItems = 0 then SetFocus hTitle: exit function
                  MENU SET STATE hMenu, 2, %MF_DISABLED                        
                  MENU SET STATE hMenu, 3, %MF_ENABLED                         
                  MENU DRAW BAR CB.HNDL                                                         
                  TREEVIEW SET BOLD CB.HNDL, %IDC_Treeview, hItem, 1
                  CONTROL SEND CB.HNDL, %IDC_Textbox, %EM_SETSEL, -1, 0                              
                  CONTROL SEND CB.HNDL, %IDC_Textbox, %EM_SCROLLCARET , 0, 0
               elseif cb.ctlmsg = %en_change then 'textbox changing here
                  fileChanged = -1
               ELSEIF CB.CTLMSG = %EN_KILLFOCUS THEN 'leaving textbox
                  insideTextbox = 0
                  MENU SET STATE hMenu, 2, %MF_ENABLED                                   
                  MENU SET STATE hMenu, 3, %MF_DISABLED                                   
                  MENU DRAW BAR CB.HNDL                                        
               END IF
            case %IDC_Treeview
            CASE %IDOK
               IF CB.CTLMSG = %BN_CLICKED AND GetParent(GetFocus) = hTreeview THEN
                  CONTROL SEND CB.HNDL, %IDC_Treeview, %TVM_EndEditLabelNow, 0, 0
               END IF                                                                           
            CASE %IDCANCEL 
               IF CB.CTLMSG = %BN_CLICKED AND GetParent(GetFocus) = hTreeview THEN
                  IF editLabel = 2 THEN 'adding topic or note
                     TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hItem
                  ELSEIF editLabel = 1 THEN 'renaming topic or note
                     CONTROL SEND CB.HNDL, %IDC_Treeview, %TVM_EndEditLabelNow, 1, 0
                  END IF
               ELSEIF lastFound then  'find mode inside of textbox
                  cancelFind(hLastFound, lastFound)      
               END IF                                          
            CASE %IDM_New
               IF fileChanged THEN
                  n = MSGBOX("Save current file?", %MB_ICONQUESTION OR %MB_YESNO, "Current File Changed")
                  IF n = %IDYES THEN saveTheFile
               END IF                                 
               thisFile = "": openTheFile()
               fileChanged = 1
            CASE %IDM_Open
               IF fileChanged THEN
                  n = MSGBOX("Save current file?", %MB_ICONQUESTION OR %MB_YESNO, "Current File Changed")
                  IF n = %IDYES THEN saveTheFile
               END IF
               ti = "Open File": 'folder = rtrim$(dataFolder, "\")
               folder = dataFolder
               flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES or %OFN_ENABLESIZING
               filter = CHR$("GenHelp (.ahp)", 0, "*.ahp", 0, "All Files (*.*)", 0, "*.*", 0)
               DISPLAY OPENFILE CB.HNDL,,, ti, folder, filter, "", "ahp", flags TO f
               IF LEN(f) AND LCASE$(f) <> LCASE$(thisFile) THEN
                  thisFile = f                                                                  
                  IF ISFILE(thisFile) THEN                                          
                     openTheFile()
                  ELSE
                     DIALOG SEND CB.HNDL, %WM_COMMAND, %IDM_New, 0
                  END IF                                                          
               END IF                                                               
            CASE %IDM_Save
               n = MSGBOX("Save file now?", %MB_ICONQUESTION OR %MB_YESNO, "Save File")
               IF n = %IDYES THEN
                  CONTROL GET TEXT hDlg, %IDC_Textbox TO texts(index)
                  saveTheFile
               end if
            CASE %IDM_SaveAs
               CONTROL GET TEXT hDlg, %IDC_Textbox TO texts(index)
               saveAsFile
            case %IDM_HelpTitle   
               helpTitle = myInput(cb.hndl, "Title:", "Title for created help file   ")
               fileChanged = 1   
            CASE %IDM_Exit                                       
               DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDM_Exit + 1 TO %IDM_Exit + 4
               n = CBCTL - %IDM_Exit: f = dataFiles(n)
               IF ISFILE(f) THEN
                  thisFile = f: openTheFile()
               else
                  msgbox f, %MB_ICONERROR, "File not found"
               end if
            CASE %IDM_AddTopic, %IDM_AddNote
               cancelFind(hLastFound, lastFound)
               INCR numItems
               REDIM PRESERVE texts(1 TO numItems)
               REDIM PRESERVE titles(1 TO numItems)
               redim preserve treeLevel(1 to numItems)
               redim preserve editOpt(1 to numItems)
               TREEVIEW GET SELECT cb.hndl, %IDC_Treeview TO hAfter
               TREEVIEW GET PARENT cb.hndl, %IDC_Treeview, hAfter TO hParent
               IF CB.CTL = %IDM_AddTopic THEN
                  IF hParent THEN hAfter = hParent
                  s = "Topic": hParent = 0: treeLevel(numItems) = 0   
               ELSE 'adding a note
                  s = "Note": IF hParent = 0 THEN hParent = hAfter: hAfter = %TVI_first
                  treeLevel(numItems) = 1          
               END IF
               s = "Add " + s
               TREEVIEW INSERT ITEM cb.hndl, %IDC_Treeview, hParent, hAfter, 0, 0, s TO hItem
               TREEVIEW SET USER CB.HNDL, %IDC_Treeview, hItem, numItems
               titles(numItems) = s 
               editOpt(numItems).tabSpaces = 8
               editOpt(numItems).nWordwrap = 1
               fileChanged = 1: editLabel = 2 
               TREEVIEW SELECT cb.hndl, %IDC_Treeview, hItem
               CONTROL SEND CB.HNDL, %IDC_Treeview, %TVM_EDITLABELW, 0, hItem
               redoTreeHandles = 1
            CASE %IDM_Rename                                                           
               editLabel = 1                                                       
               CONTROL SEND CB.HNDL, %IDC_Treeview, %TVM_EDITLABELW, 0, hItem
            case %IDM_ChangeLevel
               'treeview get select CB.HNDL, %IDC_Treeview to hItem                            
               treeview get root CB.HNDL, %IDC_Treeview to hRoot
               if hItem = hRoot then exit function 
               TREEVIEW get text CB.HNDL, %IDC_Treeview, hItem TO sItem
               n = treeLevel(index)  'treeLevel gets changed below 
               if n = 0 then 'item is a topic, change to notes
                  TREEVIEW get previous CB.HNDL, %IDC_Treeview, hItem TO hParent
                  treeview get text CB.HNDL, %IDC_Treeview, hParent TO sParent          
                  s = "Change this topic with all of its notes " + $crlf + _
                      "to notes under the topic '" + sParent + "'?"
                  n = msgbox(s, %MB_YESNO + %MB_ICONQUESTION, sItem)
                  if n = %idNo then exit function
                  cancelFind(hLastFound, lastFound)
                  '--------- first, get a list of handles for the children
                  TREEVIEW GET CHILD CB.HNDL, %IDC_Treeview, hItem TO hChild
                  numChildren = 0: REDIM hChildren(0)
                  DO WHILE hChild 'get the topic's children                                 
                     INCR numChildren: REDIM PRESERVE hChildren(numChildren)
                     hChildren(numChildren) = hChild
                     TREEVIEW GET NEXT CB.HNDL, %IDC_Treeview, hChild TO hChild                   
                  LOOP                                                                   
                  'next insert and delete the topic
                  hSavItem = hItem: treeLevel(index) = 1 
                  TREEVIEW INSERT ITEM CB.HNDL, %IDC_Treeview, hParent, %TVI_LAST, 0, 0, sItem TO hItem
                  TREEVIEW SET USER CB.HNDL, %IDC_Treeview, hItem, index  'keep same index
                  treeview select CB.HNDL, %IDC_Treeview, hItem
                  '--------- now insert and delete all children
                  FOR i = 1 TO numChildren
                     TREEVIEW GET TEXT CB.HNDL, %IDC_Treeview, hChildren(i) TO s
                     TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hChildren(i) TO k
                     TREEVIEW INSERT ITEM CB.HNDL, %IDC_Treeview, hParent, %TVI_LAST, 0, 0, s TO h
                     TREEVIEW SET USER CB.HNDL, %IDC_Treeview, h, k  'keep same indexes
                     TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hChildren(i)                                    
                  NEXT i
                  TREEVIEW delete CB.HNDL, %IDC_Treeview, hSavItem 
               else 'item is a note, change it to a topic
                  TREEVIEW get parent CB.HNDL, %IDC_Treeview, hItem TO hParent
                  treeview get text CB.HNDL, %IDC_Treeview, hParent TO sParent
                  s = "Change this item to a topic following '" + sParent + "'?"
                  n = msgbox(s, %MB_YESNO + %MB_ICONQUESTION, sItem)
                  if n = %idNo then exit function
                  cancelFind(hLastFound, lastFound)                                   
                  h = hItem
                  TREEVIEW INSERT ITEM CB.HNDL, %IDC_Treeview, 0, hParent, 0, 0, sItem TO hItem
                  treeview set user CB.HNDL, %IDC_Treeview, hItem, index  'keep same index
                  treeLevel(index) = 0
                  treeview select CB.HNDL, %IDC_Treeview, hItem 
                  TREEVIEW delete CB.HNDL, %IDC_Treeview, h
               end if
               fileChanged = 1: redoTreeHandles = 1    
            CASE %IDM_Move  'move selected item
               if moving then 'cancelling previous move                     
                  MENU SET TEXT hMenu, BYCMD %IDM_Move, "move"
                  MENU SET TEXT hTreeviewMenu, BYCMD %IDM_Move, "move"
                  MENU SET STATE hMenu, BYCMD %IDM_Move, %MF_ENABLED                  
                  MENU SET STATE hTreeviewMenu, BYCMD %IDM_Move, %MF_ENABLED
                  MENU SET STATE hMenu, BYCMD %IDM_MoveTo, %MF_GRAYED
                  MENU SET STATE hTreeviewMenu, BYCMD %IDM_MoveTo, %MF_GRAYED
                  moving = 0: exit function
               end if                                                                           
               TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hMove
               TREEVIEW GET TEXT CB.HNDL, %IDC_Treeview, hMove TO sMove
               s = "Select where this item is to be moved" + $crlf + _
                   "and click the 'MoveTo' menu item"                       
               msgbox s, %MB_iconinformation or %MB_TASKMODAL, sMove   
               TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hMove TO index 
               savIndex = index 
               if treeLevel(index) = 0 then moving = -1 else moving = 1                               
               IF moving < 0 THEN 'moving a topic, list handles for the children
                  TREEVIEW GET CHILD CB.HNDL, %IDC_Treeview, hMove TO hChild
                  numChildren = 0: REDIM hChildren(0)
                  DO WHILE hChild 'get the topic's children                                 
                     INCR numChildren: REDIM PRESERVE hChildren(numChildren)
                     hChildren(numChildren) = hChild
                     TREEVIEW GET NEXT CB.HNDL, %IDC_Treeview, hChild TO hChild
                  LOOP
               END IF
               MENU SET TEXT hMenu, BYCMD %IDM_Move, "Cancel move"
               MENU SET TEXT hTreeviewMenu, BYCMD %IDM_Move, "Cancel move"
               MENU SET STATE hMenu, BYCMD %IDM_MoveTo, %MF_ENABLED
               MENU SET STATE hTreeviewMenu, BYCMD %IDM_MoveTo, %MF_ENABLED
            CASE %IDM_MoveTo 'move to position after selected item
               n = MSGBOX("Move item now?", %MB_ICONWARNING OR %MB_YESNO, sMove)
               IF n = %IDNO THEN 'not moving anything
                  dialog send cb.hndl, %WM_COMMAND, %IDM_Move, 0
                  treeview select CB.HNDL, %IDC_Treeview, hMove
                  exit function 
               end if
               cancelFind(hLastFound, lastFound)
               'moving... first adding items, then removing the original
               TREEVIEW GET PARENT CB.HNDL, %IDC_Treeview, hItem TO hParent
               hAfter = hItem
               if hParent = 0 and moving = 1 then hParent = hItem: hAfter = %TVI_FIRST
               if hParent and moving < 0 then hAfter = hParent: hParent = 0 
               TREEVIEW INSERT ITEM CB.HNDL, %IDC_Treeview, hParent, hAfter, 0, 0, sMove TO hMoveTo 
               TREEVIEW SET USER CB.HNDL, %IDC_Treeview, hMoveTo, savIndex
               if moving < 0 then 'moving a topic with children 
                  FOR i = 1 TO numChildren
                     TREEVIEW GET TEXT CB.HNDL, %IDC_Treeview, hChildren(i) TO s
                     TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hChildren(i) TO index
                     TREEVIEW INSERT ITEM CB.HNDL, %IDC_Treeview, hMoveTo, %TVI_LAST, 0, 0, s TO hItem
                     TREEVIEW SET USER CB.HNDL, %IDC_Treeview, hItem, index  'keep same index
                     TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hChildren(i)
                  NEXT i
               END IF
               TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hMove
               treeview select CB.HNDL, %IDC_Treeview, hMoveTo
               MENU SET TEXT hMenu, BYCMD %IDM_Move, "move"              
               MENU SET TEXT hTreeviewMenu, BYCMD %IDM_Move, "move"
               MENU SET STATE hMenu, BYCMD %IDM_Move, %MF_ENABLED
               MENU SET STATE hTreeviewMenu, BYCMD %IDM_Move, %MF_ENABLED
               MENU SET STATE hMenu, BYCMD %IDM_MoveTo, %MF_GRAYED
               MENU SET STATE hTreeviewMenu, BYCMD %IDM_MoveTo, %MF_GRAYED
               fileChanged = 1: moving = 0: hItem = hMoveTo: redoTreeHandles = 1
            CASE %IDM_DeleteItem
               'just the treeview item is deleted, not elements of texts(), titles(), treeLevel(), editOpt()
               if treeLevel(index) then
                  s = "Ok to delete this note?"
               else
                  s = "Ok to delete this topic and all of its notes?"
               end if                                                     
               n = msgbox(s, %MB_iconquestion or %MB_Yesno, titles(index))
               if n = %idno then exit function
               cancelFind(hLastFound, lastFound)
               treeview get next CB.HNDL, %IDC_Treeview, hItem to hSel
               if hSel = 0 then treeview get previous CB.HNDL, %IDC_Treeview, hItem to hSel
               if hSel = 0 and treeLevel(index) then
                  treeview get parent CB.HNDL, %IDC_Treeview, hItem to hSel
               end if
               if treeLevel(index) then 'deleting a note                               
                  TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hItem
               else 'deleting a topic and all of its notes
                  do
                     treeview get child CB.HNDL, %IDC_Treeview, hItem to h
                     if h then TREEVIEW DELETE CB.HNDL, %IDC_Treeview, h   
                  loop until h = 0
                  TREEVIEW DELETE CB.HNDL, %IDC_Treeview, hItem
               end if   
               if hSel then
                  treeview select CB.HNDL, %IDC_Treeview, hSel
               else 'no items left to select  
                  numItems = 0  
                  control set text cb.hndl, %IDC_Title, ""
                  control set text cb.hndl, %IDC_Textbox, ""
                  MENU SET STATE hMenu, 2, %MF_enabled
                  menu set state hMenu, 3, %mf_disabled
               end if                                                                    
               redoTreeHandles = 1
               fileChanged = 1
            CASE %IDM_Print
               'TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hItem
               TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hItem TO index 
               TREEVIEW GET TEXT CB.HNDL, %IDC_Treeview, hItem TO ti
               printTheNote(ti, index)
            '-------- edit context help in textbox
            CASE %IDM_Undo   : SendMessage hTextbox, %WM_UNDO, 0, 0: fileChanged = 1
            CASE %IDM_Cut    : SendMessage hTextbox, %WM_CUT, 0, 0: fileChanged = 1
            CASE %IDM_Copy   : SendMessage hTextbox, %WM_COPY, 0, 0: 'fileChanged = 1           
            CASE %IDM_Paste  : SendMessage hTextbox, %WM_PASTE, 0, 0: fileChanged = 1            
            case %IDM_Delete : SendMessage hTextbox, %WM_CLEAR, 0, 0: fileChanged = 1   
            CASE %IDM_SelAll : SendMessage hTextbox, %EM_SETSEL, 0, -1
            '-----------------------------------------------------------------   
            case %IDM_Tab                                                                           
               if insideTextbox then 'simulate CTRL+TAB keys when inside textbox
                   keybd_event %VK_CONTROL, 0, 0, 0                  'Press CTRL
                   keybd_event %VK_TAB, 0, 0, 0                      'Press TAB
                   keybd_event %VK_TAB, 0, %KEYEVENTF_KEYUP, 0       'Release TAB
                   keybd_event %VK_CONTROL, 0, %KEYEVENTF_KEYUP, 0   'Release CTRL               
               end if
            case %IDM_OtherPane 'directed here with F2 key
               if insideTextbox then
                  SendMessage hTextbox, %EM_SETSEL, -1, 0
                  TREEVIEW SELECT CB.HNDL, %IDC_Treeview, hSelected                   
                  treeview set bold CB.HNDL, %IDC_Treeview, hSelected, 0
                  control set focus cb.hndl, %IDC_Treeview
                  insideTextbox = 0             
               else
                  control set focus cb.hndl, %IDC_Textbox
               end if                                                              
            CASE %IDM_ExpandAll, %IDM_Collapse                                          
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
               IF CB.CTL = %IDM_ExpandAll THEN n = 1
               TREEVIEW GET ROOT CB.HNDL, %IDC_Treeview TO hItem                          
               DO                                                              
                  TREEVIEW SET EXPANDED CB.HNDL, %IDC_Treeview, hItem, n
                  TREEVIEW GET NEXT CB.HNDL, %IDC_Treeview, hItem TO hItem
               LOOP WHILE hItem                                                    
               CONTROL SET FOCUS CB.HNDL, %IDC_Treeview
               TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hItem 
               if cb.msg = %IDM_Collapse then
                  treeview get parent CB.HNDL, %IDC_Treeview, hItem to hParent       
                  if hParent then hItem = hParent
                  treeview select CB.HNDL, %IDC_Treeview, hItem                        
               end if
               TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hItem TO index
               IF index THEN 
                  CONTROL SET TEXT CB.HNDL, %IDC_Textbox, texts(index)
                  control set text cb.hndl, %IDC_Title, titles(index)
               end if
               control send CB.HNDL, %IDC_Treeview, %TVM_SelectItem, %TVGN_FIRSTVISIBLE, hItem
               '...TREEVIEW SELECT would not bring item into view
            case %IDM_TabSpaces
               inputOpt = 1                     
               s = "Enter tab spaces:"
               ss = str$(editOpt(index).TabSpaces)                                                                
               ss = myInput(hTextbox, s, "Tab spaces", ss)    
               tabSpaces = val(ss): tabUnits = 4 * tabSpaces
               SendMessage hTextbox, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)                                 
               updateWindow hTextbox: SetFocus hTextbox 
               editOpt(index).TabSpaces = tabSpaces
               editOpt(index).nWordwrap = nWordwrap         
               fileChanged = 1
            case %IDM_WordWrap
               wordWrapToggle()                               
               SetFocus hTextbox
               editOpt(index).nWordwrap = nWordwrap                                     
               tabUnits = 4 * tabSpaces                                        
               SendMessage hTextbox, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)           
               editOpt(index).tabSpaces = tabSpaces                                                                                           
               fileChanged = 1
            case %IDM_Find                                                                            
               SendMessage hTextbox, %EM_SETSEL, -1, 0                            
               s = "Find:": inputOpt = 2: lastFound = 0              
               sFind = myInput(hTextbox, s, "Text to Find")                       
               if len(sFind) = 0 then exit function
               sFind = lcase$(sFind)                                                           
               MENU SET STATE hSrchMenu, 2, %MF_enABLED                               
               MENU SET STATE hSrchMenu, 3, %MF_enABLED                                                            
               beginFind = 1: nPos = 1: done = 0: 
               if redoTreeHandles then getTreeHandles 
               treeview set bold cb.hndl, %IDC_Treeview, hLastFound, 0 
               dialog send cb.hndl, %WM_Command, %IDM_Next, 0                     
            case %IDM_Next
               if len(sFind) = 0 then exit function
               done = 0
               do
               for i = beginFind to numTree
                  SendMessage hTextbox, %EM_SetReadOnly, 1, 0   
                  SendMessage(hTextbox, %EM_GetSel, varptr(m), varptr(n))
                  treeview get user cb.hndl, %IDC_Treeview, treeHandles(i) to k
                  sText = lcase$(texts(k))
                  if nPos = 0 then nPos = n
                  if nPos = 0 then nPos = nFound + 1          
                  found = instr(nPos, sText, sFind): nFound = found
                  notWholeWord = 0                                             
                  if found and wholeWord then
                     c1 = 0: c2 = 0
                     if found > 1 then c1 = asc(sText, found - 1)
                     if found + len(sFind) <= len(sText) then c2 = asc(sText, found + len(sFind))
                     if (c1 >= 65 and c1 <= 90) or (c2 >= 65 and c2 <= 90) then notWholeWord = 1
                     if (c1 >= 97 and c1 <= 122) or (c2 >= 97 and c2 <= 122) then notWholeWord = 1
                     if (c1 >= 48 and c1 <= 57) or (c2 >= 48 and c2 <= 57) then notWholeWord = 1
                     if notWholeWord then found = 0                                                         
                  end if
                  if found then
                     treeview select cb.hndl, %IDC_Treeview, treeHandles(i)
                     treeview unselect cb.hndl, %IDC_Treeview
                     treeview set bold cb.hndl, %IDC_Treeview, treeHandles(i), 1
                     SetFocus hTextbox                          
                     SendMessage hTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1      
                     SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                     hSelected = treeHandles(i): hLastFound = hSelected: insideTextbox = 1
                     beginFind = i: lastFound = nFound: nPos = 0
                     exit function                                    
                  elseif notWholeWord then 'no more found for this treeView item, search the next item
                     if nFound + len(sFind) <= len(sText) then 'keep searching this treeView item
                        nPos = nFound + 1: beginFind = i: exit for
                     end if                              
                  end if                                                
                  nPos = 1: if i = numTree then done = 1                                           
                  treeview set bold cb.hndl, %IDC_Treeview, treeHandles(i), 0                 
               next i
               loop until found or done
               if found = 0 then
                  if lastFound = 0 then 
                     msgbox "None found", , sFind                 
                     control set focus cb.hndl, %IDC_Treeview                                         
                     treeview select cb.hndl, %IDC_Treeview, treeHandles(index)                                              
                     exit function
                  end if                                                           
                  msgbox "No more found", , sFind
                  treeview select cb.hndl, %IDC_Treeview, hLastFound
                  treeview unselect cb.hndl, %IDC_Treeview
                  treeview set bold cb.hndl, %IDC_Treeview, hLastFound, 1             
                  SendMessage hTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
                  SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                  nPos = 0: hSelected = hLastFound
               end if                                                
            case %IDM_Prev
               if len(sFind) = 0 then exit function
               done = 0
               do                                                                                        
               for i = beginFind to 1 step -1
                  SendMessage hTextbox, %EM_SetReadOnly, -1, 0                            
                  SendMessage(hTextbox, %EM_GetSel, varptr(m), varptr(n))
                  if lastFound and m = n then sFind = "": exit function 'ends search 
                  treeview get user cb.hndl, %IDC_Treeview, treeHandles(i) to k
                  sText = lcase$(texts(k))
                  if nPos = 0 then nPos = len(sText) - m                      
                  if nPos = 0 then nPos = len(sText) - nFound
                  found = instr(-nPos, sText, sFind): nFound = found
                  notWholeWord = 0                                    
                  if found and wholeWord then                                       
                     c1 = 0: c2 = 0
                     if found > 1 then c1 = asc(sText, found - 1)
                     if found + len(sFind) <= len(sText) then c2 = asc(sText, found + len(sFind))
                     if (c1 >= 65 and c1 <= 90) or (c2 >= 65 and c2 <= 90) then notWholeWord = 1
                     if (c1 >= 97 and c1 <= 122) or (c2 >= 97 and c2 <= 122) then notWholeWord = 1
                     if (c1 >= 48 and c1 <= 57) or (c2 >= 48 and c2 <= 57) then notWholeWord = 1
                     if notWholeWord then found = 0
                  end if
                  if found then
                     treeview select cb.hndl, %IDC_Treeview, treeHandles(i)                                   
                     treeview unselect cb.hndl, %IDC_Treeview                    
                     treeview set bold cb.hndl, %IDC_Treeview, treeHandles(i), 1
                     SetFocus hTextbox            
                     SendMessage hTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1                           
                     SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                     hSelected = treeHandles(i): hLastFound = hSelected: insideTextbox = 1
                     beginFind = i: lastFound = nFound: nPos = 0
                     exit function                                                 
                  elseif notWholeWord then 'no more found for this treeView item, search the next item                   
                     if len(sText) - nFound >= 1 then 'keep searching this treeView item
                        nPos = len(sText) - nFound: beginFind = i: exit for                                         
                     end if                                    
                  end if                                                                         
                  nPos = 1: if i = 1 then done = 1
                  treeview set bold cb.hndl, %IDC_Treeview, treeHandles(i), 0                          
               next i
               loop until found or done                                                                             
               if found = 0 then
                  msgbox "No more found", , sFind                                     
                  treeview select cb.hndl, %IDC_Treeview, hLastFound
                  treeview unselect cb.hndl, %IDC_Treeview
                  treeview set bold cb.hndl, %IDC_Treeview, hLastFound, 1
                  SendMessage hTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
                  SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                  nPos = 0: hSelected = hLastFound
               end if
            case %IDM_Esc
               SendMessage hTextbox, %EM_SETSEL, -1, 0                     
               SendMessage hTextbox, %EM_SetReadOnly, 0, 0                            
               sFind = "": lastFound = 0 
               MENU SET STATE hSrchMenu, 2, %MF_disABLED                               
               MENU SET STATE hSrchMenu, 3, %MF_disABLED                                                            
            case %IDM_ProgHelp 'help for this program, F1 directed here
               ti = helpTitle
               if len(ti) = 0 then ti = "Applicaton help file"
               'appHelp helpFile, ti, cb.hndl, 50,50      
               appHelp helpFile, ti, cb.hndl
               if lastFound then                                                    
                  treeview select cb.hndl, %IDC_Treeview, hLastFound                
                  treeview unselect cb.hndl, %IDC_Treeview
                  treeview set bold cb.hndl, %IDC_Treeview, hLastFound, 1
                  SendMessage hTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
               end if
            case %IDM_RunHelp 'run help that has been generated (directed here from menu or F5)
               IF fileChanged or SendMessage(hTextbox, %EM_GETMODIFY, 0, 0) THEN saveTheFile 
               appHelp thisFile, helpTitle, cb.hndl                          
            CASE %IDM_About
               showAbout
         END SELECT
      CASE %WM_CONTEXTMENU 'treeview popup menu                 
         IF CB.WPARAM = hTreeview THEN
            pt.x = LO(INTEGER, CB.LPARAM): pt.y = HI(INTEGER, CB.LPARAM)
            IF pt.x = -1 AND pt.y = -1 THEN  'keyboard Shft+F10
               'TREEVIEW GET SELECT CB.HNDL, %IDC_Treeview TO hItem
               IF hItem = 0 THEN EXIT FUNCTION                                  
               TreeView_GetItemRect(hTreeview, hItem, BYVAL VARPTR(r), 1)                                   
               MapWindowPoints hTreeview, %NULL, BYVAL VARPTR(r), 2
               x = (r.nLeft + r.nRight) \ 2    'midpoint of treeview item
               y = (r.nTop + r.nBottom) \ 2
            ELSE 'right-click mouse
               x = pt.x: y = pt.y                                  
               ScreenToClient CB.WPARAM, pt
               tvHitInfo.pt = pt
               tvHitInfo.flags = %TVHT_ONITEMLABEL
               hItem = SendMessage(hTreeview, %TVM_HITTEST, 0, VARPTR(tvHitInfo))
               IF hItem = 0 THEN EXIT FUNCTION
               TREEVIEW SELECT CB.HNDL, %IDC_Treeview, hItem
            END IF
            TREEVIEW GET USER CB.HNDL, %IDC_Treeview, hItem TO index
            TrackPopupMenu hTreeviewMenu, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, x, y, 0, CB.HNDL, BYVAL %NULL
         END IF
      CASE %WM_DESTROY                                                                                      
      CASE %WM_SYSCOMMAND                                                            
         IF CB.CTL = %SC_CLOSE THEN 
            if numItems = 0 then exit function                     
            IF fileChanged or SendMessage(hTextbox, %EM_GETMODIFY, 0, 0) THEN
               if len(thisFile) then
                  s = "This file has changed... save it before quiting?"
               else                                                                         
                  s = "Save this new file now?"                               
               end if
               n = MSGBOX(s, %MB_YESNOCANCEL OR %MB_ICONQUESTION, "Quit Program")
               IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
               IF n = %IDyes THEN
                  CONTROL GET TEXT hDlg, %IDC_Textbox TO texts(index) 
                  saveTheFile
               end if                                          
            END IF
            dialog end appHelp_hDlg
         END IF
   END SELECT                                                     
END FUNCTION 
                    
FUNCTION subClassTextbox(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL x, y AS LONG                                                                                        
   local pt AS POINTAPI                                                                                  
   SELECT CASE wMsg& 
      Case %WM_ContextMenu
         'this routine replaces the Windows built-in right click menu
         'WM_ContextMenu returns xy coordinates of mouse
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         TrackPopupMenuEx hTextboxMenu, 0, pt.x, pt.y, hDlg, BYVAL 0
         Function = 0 : Exit Function                                       
   END SELECT
   ' Pass the message on to the original window procedure                            
   FUNCTION = CallWindowProc(origTextboxProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION
                                       
SUB wordWrapToggle()                                                                  
   'just re-create textbox without %WS_HSCROLL and %ES_AUTOHSCROLL styles
   LOCAL x, y, wi, ht, nStyle, margins AS LONG
   LOCAL sText AS STRING                                                      
   fileChanged = SendMessage(hTextbox, %EM_GETMODIFY, 0, 0)        
   control get text hDlg, %IDC_Textbox to sText
   control get loc hDlg, %IDC_Textbox to x, y
   CONTROL GET SIZE hDlg, %IDC_Textbox TO wi, ht
   CONTROL KILL hDlg, %IDC_Textbox
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN _
          OR %ES_NOHIDESEL 'or %WS_TABSTOP                            
   IF nWordWrap = 1 THEN
      nWordWrap = 0                                                                                     
      nStyle = nStyle OR %WS_HSCROLL OR %ES_AUTOHSCROLL
      MENU SET STATE hMenu, BYCMD %IDM_WordWrap, %MF_UNCHECKED
   ELSE 'nWordWrap = 0
      nWordWrap = 1
      MENU SET STATE hMenu, BYCMD %IDM_WordWrap, %MF_CHECKED
   END IF                                                              
   CONTROL ADD textbox, hDlg, %IDC_Textbox, "", x, y, wi, ht, nStyle
   CONTROL HANDLE hDlg, %IDC_Textbox TO hTextbox
   margins = %EC_LEFTMARGIN or %EC_RIGHTMARGIN                           
   SendMessage hTextbox, %EM_SETMARGINS, margins, MAK(DWORD, 12, 12)
   CONTROL SET FONT hDlg, %IDC_Textbox, hFont                                
   control set text hDlg, %IDC_Textbox, sText
   SendMessage(hTextbox, %EM_SETMODIFY, fileChanged, 0)   
   lastWordwrap = nWordwrap
   origTextboxProc = SetWindowLong(hTextbox, %GWL_WNDPROC, CodePtr(subClassTextbox))       
END SUB

sub getTreeHandles()
   'get handles to the tree items in the order of the expanded tree
   '-----------------------------------------------------------------------------
   local i, n, hItem, hTopic, lastItem as long                                     
   treeview get count hDlg, %IDC_Treeview to numTree      
   redim treeHandles(1 to numTree)
   treeview get root hDlg, %IDC_Treeview to hItem: hTopic = hItem 
   lastItem = 0: treeHandles(1) = hItem: treeLevel(1) = 0                 
   for i = 2 to numTree
      if lastItem = 0 then 'last item was a parent
         treeview get child hDlg, %IDC_Treeview, hTopic to hItem: lastItem = 1
         if hItem = 0 then 'no children, get next parent
            treeview get next hDlg, %IDC_Treeview, hTopic to hTopic: lastItem = 0         
         end if
      else 'last item was a child
         treeview get next hDlg, %IDC_Treeview, hItem to hItem: lastItem = 1                                  
         if hItem = 0 then 'no more children, get next parent
            treeview get next hDlg, %IDC_Treeview, hTopic to hTopic: lastItem = 0 
         end if                                 
      end if
      if lastItem = 0 then hItem = hTopic
      treeHandles(i) = hItem
   next i
   redoTreeHandles = 0                                                 
end sub
        
sub cancelFind(hSel as long, lastFound as long)
   if lastFound = 0 then exit sub
   MENU SET STATE hSrchMenu, 2, %MF_disABLED                               
   MENU SET STATE hSrchMenu, 3, %MF_disABLED           
   SendMessage hTextbox, %EM_SETSEL, -1, 0
   treeview unselect hDlg, %IDC_Treeview                       
   TREEVIEW SELECT hDlg, %IDC_Treeview, hSel                                                             
   treeview set bold hDlg, %IDC_Treeview, hSel, 0
   lastFound = 0
end sub                                                                  
                                                                       
sub AttachMenu()                                       
   local i, m, n as long, s as string                                  
   MENU NEW BAR TO hMenu
   'declare menu popups
   MENU NEW POPUP TO hFileMenu                   
   MENU NEW POPUP TO hItemMenu
   MENU NEW POPUP TO hEditMenu
   menu new popup to hSrchMenu
   MENU NEW POPUP TO hHelpMenu
   'top menus
   MENU ADD POPUP, hMenu, "File", hFileMenu, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Item", hItemMenu, %MF_disABLED
   MENU ADD POPUP, hMenu, "Edit", hEditMenu, %MF_disABLED
   menu add popup, hMenu, "Search", hSrchMenu, %MF_ENABLED            
   MENU ADD popup, hMenu, "Help", hHelpMenu, %MF_ENABLED
   'drop down File menu
   MENU ADD STRING, hFileMenu, "New", %IDM_New, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Open", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "SaveAs", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0 
   MENU ADD STRING, hFileMenu, "Help title", %IDM_HelpTitle, %MF_ENABLED           
   MENU ADD STRING, hFileMenu, "-", 0, 0 
   MENU ADD STRING, hFileMenu, "Exit", %IDM_Exit, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0 
   FOR i = 1 TO 4
      s = dataFiles(i)                             
      IF LEN(s) = 0 THEN EXIT FOR
      if ucase$(pathname$(path, s)) = ucase$(dataFolder) then s = pathname$(namex, s)
      s = "&" + TRIM$(STR$(i)) + " " + s
      MENU ADD STRING, hFileMenu, s, %IDM_Exit + i, %MF_ENABLED
   NEXT i
   'drop down Item menu                                                                  
   MENU ADD STRING, hItemMenu, "Add Topic", %IDM_AddTopic, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Add Note", %IDM_AddNote, %MF_ENABLED                        
   MENU ADD STRING, hItemMenu, "Change Level", %IDM_ChangeLevel, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Move", %IDM_Move, %MF_enablED  
   MENU ADD STRING, hItemMenu, "Move to", %IDM_MoveTo, %MF_grayED
   MENU ADD STRING, hItemMenu, "-", 0, 0
   MENU ADD STRING, hItemMenu, "Rename", %IDM_Rename, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Delete item", %IDM_DeleteItem, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Print item", %IDM_Print, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Expand all", %IDM_ExpandAll, %MF_ENABLED
   MENU ADD STRING, hItemMenu, "Collapse all", %IDM_Collapse, %MF_ENABLED
   'drop down Edit menu
   MENU ADD STRING, hEditMenu, "Undo" & $TAB & "CTRL+Z", %IDM_Undo, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Cut" & $TAB & "CTRL+X", %IDM_Cut, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Copy" & $TAB & "CTRL+C", %IDM_Copy, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Paste" & $TAB & "CTRL+V", %IDM_Paste, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Select all" & $TAB & "CTRL+A", %IDM_SelAll, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "Tab Spaces", %IDM_TabSpaces, %MF_ENABLED
   menu add string, hEditMenu, "Word wrap", %IDM_WordWrap, %MF_ENABLED or %MFS_CHECKED 
   'drop down Search menu
   menu add string, hSrchMenu, "Find" & $tab & "CTRL+F", %IDM_Find, %MF_ENABLED 
   menu add string, hSrchMenu, "Find next" & $tab & "F3", %IDM_Next, %MF_disABLED
   menu add string, hSrchMenu, "Find prev" & $tab & "SHFT+F3", %IDM_Prev, %MF_disABLED
   menu add string, hSrchMenu, "Find cancel" & $tab & "Escape", %IDCANCEL, %mf_enabled
   'drop down Help menu
   MENU ADD STRING, hHelpMenu, "Help for this App" & $tab & "F1", %IDM_ProgHelp, %MF_ENABLED
   Menu add string, hHelpMenu, "Run created Help" & $tab & "F5", %IDM_RunHelp, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "About", %IDM_About, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
'--------------------------------------------------------------------------------------------
   'create popup menu for treeview control
   MENU NEW POPUP TO hTreeviewMenu             
   MENU ADD STRING, hTreeviewMenu, "Add Topic", %IDM_AddTopic, %MF_ENABLED
   MENU ADD STRING, hTreeviewMenu, "Add Note", %IDM_AddNote, %MF_ENABLED
   MENU ADD STRING, hTreeviewMenu, "Change Level", %IDM_ChangeLevel, %MF_ENABLED
   MENU ADD STRING, hTreeviewMenu, "Move", %IDM_Move, %MF_enablED
   MENU ADD STRING, hTreeviewMenu, "Move to", %IDM_MoveTo, %MF_grayED
   MENU ADD STRING, hTreeviewMenu, "-", 0, 0
   MENU ADD STRING, hTreeviewMenu, "Rename", %IDM_Rename, %MF_ENABLED
   MENU ADD STRING, hTreeviewMenu, "Delete item", %IDM_DeleteItem, %MF_ENABLED
   MENU ADD STRING, hTreeviewMenu, "Print item", %IDM_Print, %MF_ENABLED 
   MENU ADD STRING, hTreeviewMenu, "Expand all", %IDM_ExpandAll, %MF_ENABLED
'--------------------------------------------------------------------------------------------
   'create popup menu for textbox control                      
   MENU NEW POPUP TO hTextboxMenu                                                                   
   MENU ADD STRING, hTextboxMenu, "Undo", %IDM_Undo, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Cut", %IDM_Cut, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Copy", %IDM_Copy, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Paste", %IDM_Paste, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Delete", %IDM_Delete, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "-", 0, 0
   MENU ADD STRING, hTextboxMenu, "Select All", %IDM_SelAll, %MF_ENABLED
END sub
                                                      
SUB openTheFile() 
   LOCAL fileNo, i, j, n, hItem AS LONG                   
   local s as string                   
   LOCAL k AS WORD
   IF ISFILE(thisFile) THEN 'file exists... so, open it
      fileNo = FREEFILE
      OPEN thisFile FOR BINARY AS fileNo
      GET fileNo,, numItems
      if numItems <= 0 then                          
         msgbox "Cannot open... no items", %MB_iconerror
         close fileNo                                                  
      end if              
      REDIM texts(1 TO numItems)                                            
      REDIM titles(1 TO numItems)
      redim treeLevel(1 to numItems)
      redim editOpt(1 to numItems)            
      redim treeHandles(1 to numItems)
      FOR i = 1 TO numItems
'         GET fileNo,, k: texts(i) = SPACE$(k)
'         GET fileNo,, texts(i)
         GET fileNo,, k
         GET$ fileNo, k, texts(i)
      NEXT i                                                             
      FOR i = 1 TO numItems                                                
'         GET fileNo,, k: titles(i) = SPACE$(k)
'         GET fileNo,, titles(i)                                                               
         GET fileNo,, k
         GET$ fileNo, k, titles(i)                                                               
      NEXT i
      get fileNo,, treeLevel()
      get fileNo,, editOpt()
      get fileNo,, k
      get$ fileNo, k, helpTitle
      CLOSE fileNo
      fileChanged = 0 
      SendMessage(hTextbox, %EM_SETMODIFY, 0, 0)          
   ELSE 'new file
      numItems = 1
      REDIM titles(1 TO numItems)
      REDIM texts(1 TO numItems)
      redim treeLevel(1 to numItems)
      redim editOpt(1 to numItems)
      redim treeHandles(1 to numItems)

      titles(1) = "First Topic"
      texts(1) = ""
      treeLevel(1) = 0                                                                          
      fileChanged = 0
      SendMessage(hTextbox, %EM_SETMODIFY, 0, 0)
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_Rename, 0
   END IF
   showTreeview()
END SUB      
                                        
SUB saveAsFile()
   'current file is saved as another file                                                                  
   LOCAL flags AS LONG                               
   LOCAL f, ti, folder, filter AS STRING
   ti = "Save File": folder = rtrim$(dataFolder, "\")
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES or %OFN_ENABLESIZING
   filter = CHR$("GenHelp", 0, "*.ahp", 0, "All Files", 0, "*.*", 0)
   DISPLAY SAVEFILE hDlg,,, ti, folder, filter, "", "ahp", flags TO f
   IF LEN(f) THEN
      IF ISFILE(f) THEN KILL f
      thisFile = f: saveTheFile
   END IF
END SUB

SUB saveTheFile()                                                           
   LOCAL fileNo, i, j, n AS LONG
   LOCAL k AS WORD, s AS STRING 
   IF LEN(thisFile) = 0 THEN saveAsFile
   if redoTreeHandles then getTreeHandles
   'first, update the ini file ----------------------------------------------
   s = thisFile: j = 4
   if len(s) then                           
      for i = 1 to 4               
         'check if thisFile is among the listed four                  
         if lcase$(dataFiles(i)) = lcase$(s) then j = i: exit for                        
      next i
      FOR i = j TO 2 STEP -1                               
         dataFiles(i) = dataFiles(i - 1)                                                 
      NEXT i                                                
      dataFiles(1) = s  'the opened file should be first on the list
      fileNo = FREEFILE
      OPEN iniFile FOR OUTPUT AS fileNo
      PRINT #fileNo, dataFiles()
      CLOSE #fileNo
      attachMenu() 'needed if continuing after save                                              
   end if          
   'save the indexes so that help contents need not be moved -------------------            
   treeview get count hDlg, %IDC_Treeview to numTree
   dim indexes(1 to numTree) as long
   for i = 1 to numTree 
      TREEVIEW GET USER hDlg, %IDC_Treeview, treeHandles(i) TO n
      indexes(i) = n                     
   next i
   'now, save the data file ---------------------------------------------------- 
   'texts(), titles(), treeLevel(), editOpt()... only those used will be saved
   'CONTROL GET TEXT hDlg, %IDC_Textbox TO texts(index) 
   fileNo = FREEFILE                      
   OPEN thisFile FOR BINARY AS fileNo
   PUT fileNo,, numTree
   FOR i = 1 TO numTree 
      s = texts(indexes(i))
      k = LEN(s): PUT fileNo,, k
      PUT fileNo,, s
   NEXT i
   FOR i = 1 TO numTree 'titles()
      s = titles(indexes(i))
      k = LEN(s): PUT fileNo,, k
      PUT$ fileNo, s 
   NEXT i
   for i = 1 to numTree 'treeLevel()         
      PUT fileNo,, treeLevel(indexes(i))
   next i                                                
   for i = 1 to numTree 'editOpt() 
      PUT fileNo,, editOpt(indexes(i))
   next i
   k = len(helpTitle): put fileNo,, k
   put$ fileNo, helpTitle
   CLOSE fileNo
   fileChanged = 0
   SendMessage(hTextbox, %EM_SETMODIFY, 0, 0)
END SUB 

SUB showTreeview() 
   'show treeview just after file is opened using treeLevel() and titles()
   'note that now in the beginning, numTree = numItems 
   '---------------------------------------------------------------------------------
   LOCAL hTopic, hItem, index, i, j, n AS LONG
   LOCAL s AS STRING
   if numItems = 0 then exit sub
   numTree = numItems
   doNotNotify = 1: TREEVIEW RESET hDlg, %IDC_Treeview: doNotNotify = 0
   FOR i = 1 TO numItems                                                     
      j = treeLevel(i)                          
      s = titles(i)
      IF j THEN 'treeview item is a note
         TREEVIEW INSERT ITEM hDlg, %IDC_Treeview, hTopic, %TVI_LAST, 0, 0, s TO hItem 
         TREEVIEW SET USER hDlg, %IDC_Treeview, hItem, i
         treeHandles(i) = hItem
      ELSE 'treeview item is a topic
         TREEVIEW INSERT ITEM hDlg, %IDC_Treeview, 0, %TVI_LAST, 0, 0, s TO hTopic
         TREEVIEW SET USER hDlg, %IDC_Treeview, hTopic, i
         treeHandles(i) = hTopic                         
      END IF
   NEXT i
   for i = 1 to numItems 'show in expanded form
      hItem = treeHandles(i)                                                                              
      if hItem = 0 then exit for
      'treeview get user hDlg, %IDC_Treeview, hItem to index
      'if n = 0 and len(texts(index)) then n = i
      treeview set expanded hDlg, %IDC_Treeview, hItem, 1                           
   next i
   'select first item in tree with content, update menu and statusbar
   'hItem = treeHandles(n)
   hItem = treeHandles(1)
   TREEVIEW SELECT hDlg, %IDC_Treeview, hItem
   TREEVIEW GET USER hDlg, %IDC_Treeview, hItem TO index
   TREEVIEW GET text hDlg, %IDC_Treeview, hItem TO s
   control set text hDlg, %IDC_Title, space$(5) + s
   CONTROL SET TEXT hDlg, %IDC_Textbox, texts(index)
   statusbar set text hDlg, %IDC_StatusBar, 1, 0, thisFile  
   menu set state hMenu, 2, %MF_ENABLED 
   MENU SET STATE hMenu, 3, %MF_disABLED
   MENU DRAW BAR hDlg
   redoTreeHandles = 0
END SUB                                              
      
SUB createFolder(folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s AS STRING
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(s) = 0 THEN MKDIR s
      END IF
   NEXT i
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize                                  
   FUNCTION = TmpAsciiz
END FUNCTION

SUB printTheNote(title AS STRING, index AS LONG)
   LOCAL m, n, k, i, j, mm, nLines, maxLines, tabCount, pgNo, multPgs, prn AS LONG
   LOCAL printerName, TXT, s, tabStr() AS STRING
   local temp as string
   'local temp as wstring 
   LOCAL leftMargin, topMargin, rightMargin, bottomMargin, pageWidth, pageHeight AS DOUBLE
   LOCAL x, wi, charHt, maxWidth AS DOUBLE
   LOCAL oTPrint AS iTPrint
   LET oTPrint = CLASS "cTPrint"
   TXT = texts(index)
   printerName = oTPrint.choosePrinter
   IF LEN(printerName) = 0 THEN EXIT SUB
   leftMargin = .75: topMargin = .25: rightMargin = .75: bottomMargin = .50
   oTPrint.setMargins(leftMargin, rightMargin, topMargin, bottomMargin)
   oTPrint.getPageSize(pageWidth, pageHeight)
   maxWidth = pageWidth - leftMargin - rightMargin
   oTPrint.newFont("Courier New", 9)
   maxLines = oTPrint.getLines: n = 1: nLines = 4
   IF oTPrint.duplexSet THEN
      GOSUB printPage: multPgs = ABS(multPgs) 'test for multiple pages
      oTPrint.duplexPrint(multPgs + 1)
   END IF
   prn = 1
   wi = oTPrint.getTextWidth("Page 1")
   oTPrint.beginDoc("GenHelp")
   oTPrint.beginPage
   oTPrint.printText(title, leftMargin, topMargin)
   oTPrint.printText("Page 1", pageWidth - rightMargin - wi, topMargin)
   oTPrint.getCharSize(x, charHt)
   oTPrint.setPos(leftMargin, 4 * charHt)
   n = 1: nLines = 4: pgNo = 1                                                                    
   GOSUB printPage
   oTPrint.closePage
   oTPrint.closeDoc
   EXIT SUB

   printPage:
      DO
         k = INSTR(n, TXT, CHR$(13, 10))
         IF k THEN
            temp = MID$(TXT, n, k - n): INCR k
         ELSE
            temp = MID$(TXT, n): k = LEN(TXT)
         END IF

         tabCount = PARSECOUNT(temp, CHR$(9))
         IF tabCount > 1 THEN 'process tabs
            REDIM tabStr(1 TO tabCount)
            PARSE temp, tabStr(), CHR$(9)
            temp = ""
            FOR i = 1 TO tabCount - 1
               s = SPACE$(8)
               j = 8 - (LEN(tabStr(i)) MOD 8)
               IF j THEN s = SPACE$(j)
               temp = temp + tabStr(i) + s
            NEXT i
            temp = temp + tabStr(tabCount)
         END IF

         x = oTPrint.getTextWidth(temp)
         IF x <= maxWidth THEN 'print the line
            IF prn THEN oTPrint.printText(temp)
            INCR nLines
         ELSE 'else temp is too long... must break into lines
            DO
               s = oTPrint.truncate(temp, maxWidth)
               m = INSTR(-1, s, ANY " -,;:.()[]{}<>~/|\=")
               mm = INSTR(MID$(s, m, 1), ANY "([{<")
               IF prn THEN oTPrint.printText(TRIM$(LEFT$(temp, m - mm)))
               temp = MID$(temp, m - mm + 1): INCR nLines
               IF nLines > maxLines THEN GOSUB nextPage
            LOOP WHILE m
         END IF
         IF nLines > maxLines THEN GOSUB nextPage
         n = k + 1
      LOOP WHILE n < LEN(TXT)
      RETURN

   nextPage:
      IF multPgs <= 0 THEN multPgs = -1: RETURN
      oTPrint.closePage
      oTPrint.beginPage
      nLines = 4: INCR pgNo
      wi = oTPrint.getTextWidth("Page" + STR$(pgNo))
      oTPrint.printText(title, leftMargin, topMargin)
      oTPrint.printText("Page" + STR$(pgNo), pageWidth - rightMargin - wi, topMargin)
      oTPrint.setPos(leftMargin, 4 * charHt)
      RETURN
END SUB

FUNCTION myInput(OPT BYVAL hParent AS LONG, BYVAL prompt AS STRING, _   
                     BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string used to specify textbox size
   '      for 3 lines, use def = SPACE$(60)) + $CRLF + $CRL
   'function serves two msgboxes: tabs and find
   '-----------------------------------------------------------------------------
   LOCAL hInput, hdc, nStyle, hFont, numLines, ht, wi, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, sz AS asciiZ * 256, s, myInputStr AS STRING                                              
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, hParent, ti, , , 0, 0, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   numLines = parsecount(def, $crlf)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = MAX(t.cx, 130)
   sz = ti + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = MAX(t.cx, 150)
   wi = MAX(w1 + w2, w3, 150)
   ht = t.cy * numLines + 10
   IF hParent THEN                                                                                           
      DIALOG GET CLIENT hParent TO x, y
   ELSE
      DESKTOP GET CLIENT TO x, y
   END IF
   x = x/2 - wi/2: y = y/4
   DIALOG SET LOC hInput, x, y
   DIALOG SET SIZE hInput, wi + 40, ht + 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20         
   nStyle = 0
   if numLines > 1 then nStyle = %ES_MULTILINE or %ES_WANTRETURN
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 10, 15, w2 + 5, ht, nStyle, %WS_EX_CLIENTEDGE
   IF LEN(def) THEN CONTROL SEND hInput, 9999, %EM_SETSEL, 0, -1
   if inputOpt = 1 then                
      s = "Turn off word wrap to preserve columns"
      control add checkbox, hInput, 9998, s, 10, 50, 220, 15
   elseif inputOpt = 2 then
      s = "Whole word"                                            
      control add checkbox, hInput, 9998, s, 10, 50, 220, 15 
   end if
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", wi - 60, ht + 50, 80, 30
   DIALOG SET USER hInput, 1, VARPTR(myInputStr)
   DIALOG SHOW MODAL hInput, CALL myInputProc
   'ReleaseDC hInput, hdc
   FUNCTION = TRIM$(myInputStr)           
END FUNCTION
                                                                                       
CALLBACK FUNCTION myInputProc()
   local nCheck as long                               
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
         control set check cb.hndl, 9998, 1
         wholeWord = 0                                                 
      CASE %WM_COMMAND
         if cb.ctl = %IDOK then
            control get check cb.hndl, 9998 to nCheck
            if nCheck then wholeWord = 1                             
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps
            DIALOG END CB.HNDL
         elseif CB.CTL = %IDCANCEl then
            DIALOG END CB.HNDL 
         end if 
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

SUB showAbout
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hDlg,"About GenHelp",,, 240, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "App Help Generator", 30, 10, 120, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 150, 13, 70, 10
   s = "Version " + $ver + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 40, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "GenHelp", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL showAboutProc
END SUB

CALLBACK FUNCTION showAboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CB.MSG
   CASE %WM_PAINT
      FONT NEW "MS Sans Serif", 14 TO hFont                                   
      CONTROL SET COLOR CB.HNDL, 9901, %RED, -1
      CONTROL SET FONT CB.HNDL, 9901, hFont
      FONT NEW "MS Sans Serif", 10, 2 TO hFont
      CONTROL SET FONT CB.HNDL, 9902, hFont
      FONT NEW "MS Sans Serif", 10 TO hFont
      CONTROL SET FONT CB.HNDL, 9903, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9904, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9904, hFont                            
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9905, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9905, hFont
      FONT END hFont              
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(%NULL, BYVAL %IDC_HAND)
         SetWindowLong CB.HNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
         DIALOG END CB.HNDL
      ELSEIF CB.CTL = 9904 THEN
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CB.CTL = 9905 THEN
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION     
